const path = require('path');
const webpack = require('webpack');

module.exports = {
  name: 'minified',
  devtool: 'source-map',
  entry: './src/index.js',
  output: {
    filename: 'shuffle.min.js',
    path: './dist',
    library: 'shuffle',
    libraryTarget: 'umd',
  },
  resolve: {
    root: [path.resolve('./src')],
  },
  module: {
    loaders: [
      {
        test: /\.js$/,
        exclude: /node_modules/,
        loader: 'babel',
      },
    ],
  },
  plugins: [
    new webpack.optimize.DedupePlugin(),
    new webpack.optimize.UglifyJsPlugin({
      comments: false,
      screw_ie8: true,
      compress: {
        drop_console: true,
      },
      mangle: true,
    }),
  ],
};
